package test4.ejb;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.ejb.Lock;
import javax.ejb.LockType;
import javax.ejb.Schedule;
import javax.ejb.Singleton;
import javax.ejb.Startup;
import javax.servlet.AsyncContext;

@Singleton
@Startup
public class ClientHandler {
	private List<AsyncContext> clients = new ArrayList<AsyncContext>();
	@Lock(LockType.WRITE)
	public void register(AsyncContext ac) {
		clients.add(ac);
	}
	@Schedule(second="*/1", minute="*",hour="*", persistent=false)
	@Lock(LockType.WRITE)
	private void process() {
		for(AsyncContext ac : clients) {
			try {
				ac.getResponse().getOutputStream().println("{ \"txt\":\"" + (new Date()) + "\"}");
				ac.complete();
			} catch (IOException e) {
				e.printStackTrace();
			};
		}
		clients.clear();
	}
}
