package test4.ejb;

import java.util.List;

import javax.annotation.Resource;
import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

@Remote(TestManager.class)
@Stateless
public class TestManagerBean implements TestManager {
	@PersistenceContext
	private EntityManager em;
	@Resource(mappedName="java:/JmsXA")
	private ConnectionFactory cf;
	@Resource(mappedName="java:jboss/exported/jms/queue/testmanager")
	private Queue q;
	@Override
	public T1 getOne(int id) {
		T1 o = em.find(T1.class, id);
		return o;
	}
	@Override
	public List<T1> getAll() {
		@SuppressWarnings("unchecked")
		List<T1> res = em.createQuery("SELECT t FROM T1 AS t").getResultList();
		return res;
	}
	@Override
	public void save(T1 o) {
		em.persist(o);
	}
	@Override
	public void saveDelayed(T1 o) {
		try {
			Connection c = cf.createConnection();
			Session ses = c.createSession(false,  Session.AUTO_ACKNOWLEDGE);
			MessageProducer sender = ses.createProducer(q);
			sender.send(ses.createObjectMessage(o));
			c.close();
		} catch (JMSException e) {
			e.printStackTrace();
		}
	}
}
